/*
 * Created on Sep 28, 2005
 *
 * TODO Implement it, then write some documentation
 *
 */
package se.umu.jobsubmission.client;


import java.io.File;
import java.io.StringWriter; 

import org.apache.axis.message.MessageElement;
import org.apache.axis.types.NCName;
import org.apache.axis.types.NonNegativeInteger;
import org.apache.axis.types.PositiveInteger;
import org.apache.axis.types.URI;
import org.ggf.schemas.jsdl._2005._11.jsdl.Application_Type;
import org.ggf.schemas.jsdl._2005._11.jsdl.DataStaging_Type;
import org.ggf.schemas.jsdl._2005._11.jsdl.Exact_Type;
import org.ggf.schemas.jsdl._2005._11.jsdl.JobDefinition_Type;
import org.ggf.schemas.jsdl._2005._11.jsdl.JobDescription_Type;
import org.ggf.schemas.jsdl._2005._11.jsdl.JobIdentification_Type;
import org.ggf.schemas.jsdl._2005._11.jsdl.RangeValue_Type;
import org.ggf.schemas.jsdl._2005._11.jsdl.Resources_Type;
import org.ggf.schemas.jsdl._2005._11.jsdl.SourceTarget_Type;
import org.ggf.schemas.jsdl._2005._11.jsdl_posix.Argument_Type;
import org.ggf.schemas.jsdl._2005._11.jsdl_posix.DirectoryName_Type;
import org.ggf.schemas.jsdl._2005._11.jsdl_posix.Environment_Type;
import org.ggf.schemas.jsdl._2005._11.jsdl_posix.FileName_Type;
import org.ggf.schemas.jsdl._2005._11.jsdl_posix.POSIXApplication_Type;
import org.globus.exec.generated.JobDescriptionType;
import org.globus.exec.generated.NameValuePairType;
import org.globus.exec.utils.rsl.RSLHelper;
import org.globus.rft.generated.TransferRequestType;
import org.globus.rft.generated.TransferType;
import org.globus.wsrf.encoding.ObjectSerializer;
import org.globus.wsrf.utils.AnyHelper;

import se.umu.jobsubmission.util.JobDescriptionTranslator;

/**
 * @author tordsson
 *
 * TODO Add a proper description of this class. 
 */
public class RSL2JSDL implements JobDescriptionTranslator {
	
	public Object translate(Object jobDescriptionFileName) throws Exception {
		
    	File jobDescriptionFile = new File((String)jobDescriptionFileName); 
		JobDescriptionType rsl = RSLHelper.readRSL(jobDescriptionFile);		
		
		JobDefinition_Type jsdl = new JobDefinition_Type(); 
		JobDescription_Type jsdlDesc = new JobDescription_Type(); 
		Application_Type application = new Application_Type(); 
		Resources_Type resource = new Resources_Type(); 
		POSIXApplication_Type posixApplication = new POSIXApplication_Type(); 
		
		// Executable
		String executable = rsl.getExecutable(); 
		if(executable != null) {
			FileName_Type exec = new FileName_Type(executable); 
			posixApplication.setExecutable(exec); 
		}
		
		// Arguments: 
		String arguments[] = rsl.getArgument(); 
		if(arguments != null) {
			Argument_Type jsdlArgs[] = new Argument_Type[arguments.length]; 
			for(int i = 0; i < arguments.length; i++) {
				jsdlArgs[i] = new Argument_Type(arguments[i]); 
			}
			posixApplication.setArgument(jsdlArgs); 
		}
		
		// Stdin: 
		String stdin = rsl.getStdin(); 
		if(stdin != null) {
			FileName_Type stdinFile = new FileName_Type(stdin); 
			posixApplication.setInput(stdinFile); 
		}
		
		// Stdout: 
		String stdout = rsl.getStdout(); 
		if(stdout != null) {
			FileName_Type stdoutFile = new FileName_Type(stdout); 
			posixApplication.setOutput(stdoutFile); 
		}
		
		// Stderr: 
		String stderr = rsl.getStderr(); 
		if(stderr != null) {
			FileName_Type stderrFile = new FileName_Type(stderr); 
			posixApplication.setError(stderrFile); 
		}		
		
		// Directory:
		String directory = rsl.getDirectory(); 
		if(directory != null) {
			DirectoryName_Type dir = new DirectoryName_Type(); 
			dir.set_value(directory); 
			posixApplication.setWorkingDirectory(dir); 
		}
		
		// Environment
		NameValuePairType environment[] = rsl.getEnvironment(); 
		if(environment != null) {
			Environment_Type env[] = new Environment_Type[environment.length]; 
			for(int i = 0; i < environment.length; i++) {
				String name = environment[i].getName(); 
				String value = environment[i].getValue(); 
				env[i] = new Environment_Type(); 
				env[i].set_value(value); 
				env[i].setName(new NCName(name)); 
				
			}
			posixApplication.setEnvironment(env);
		}
		
		// Project
		String project = rsl.getProject(); 
		if(project != null) {
			JobIdentification_Type jobId = new JobIdentification_Type(); 
			jobId.setJobProject(new String[]{project}); 
			jsdlDesc.setJobIdentification(jobId); 
		}
		
		// fileStageIn
		TransferRequestType stageIn = rsl.getFileStageIn(); 
		if(stageIn != null) {
			TransferType transfer[] = stageIn.getTransfer(); 
			DataStaging_Type staging[] = new DataStaging_Type[transfer.length]; 
			for(int i = 0; i < transfer.length; i++) {
				String source = transfer[i].getSourceUrl(); 
				String target = transfer[i].getDestinationUrl();
				System.out.println("Source: " + source + " target: " + target); 
				staging[i] = new DataStaging_Type(); 
				staging[i].setFileName(source);
				SourceTarget_Type sourceFile = new SourceTarget_Type(); 
				sourceFile.setURI(new URI(target)); 
				staging[i].setSource(sourceFile); 
			}
			// Need not worry about outputfiles, these are converted later
			jsdlDesc.setDataStaging(staging); 
		}
		
		// Stageout
		TransferRequestType stageOut = rsl.getFileStageOut(); 
		if(stageOut != null) {
			TransferType transfer[] = stageOut.getTransfer(); 
			DataStaging_Type output[] = new DataStaging_Type[transfer.length]; 
			for(int i = 0; i < transfer.length; i++) {
				String source = transfer[i].getSourceUrl(); 
				String target = transfer[i].getDestinationUrl();
				output[i] = new DataStaging_Type(); 
				output[i].setFileName(source); 
				SourceTarget_Type destinationFile = new SourceTarget_Type(); 
				destinationFile.setURI(new URI(target)); 
				output[i].setTarget(destinationFile); 
			}
			DataStaging_Type input[] = jsdlDesc.getDataStaging(); 
			if(input == null) {
				jsdlDesc.setDataStaging(output); 
			}
			else {
				// Also existed some input staging directives, 
				// merge this with outputstaging ones. 
				DataStaging_Type newStaging[] = 
					new DataStaging_Type[output.length + input.length]; 
				int i; 
				for(i = 0; i < input.length; i++) {
					newStaging[i] = new DataStaging_Type(); 
					newStaging[i].setCreationFlag(input[i].getCreationFlag());  
					newStaging[i].setDeleteOnTermination(input[i].getDeleteOnTermination()); 
					newStaging[i].setFileName(input[i].getFileName()); 
					newStaging[i].setFilesystemName(input[i].getFilesystemName()); 
					newStaging[i].setName(input[i].getName()); 
					newStaging[i].setSource(input[i].getSource()); 
					newStaging[i].setTarget(input[i].getTarget()); 
				}
				for(int j = 0; i < (input.length + output.length); i++, j++) {
					newStaging[i] = new DataStaging_Type(); 
					newStaging[i].setCreationFlag(output[j].getCreationFlag());  
					newStaging[i].setDeleteOnTermination(output[j].getDeleteOnTermination()); 
					newStaging[i].setFileName(output[j].getFileName()); 
					newStaging[i].setFilesystemName(output[j].getFilesystemName()); 
					newStaging[i].setName(output[j].getName()); 
					newStaging[i].setSource(output[j].getSource()); 
					newStaging[i].setTarget(output[j].getTarget()); 
				}
				jsdlDesc.setDataStaging(newStaging); 
			}
		} 
			
		// Count
		PositiveInteger count = rsl.getCount(); 
		if(count != null) {
			int countValue = count.intValue(); 
			RangeValue_Type value = new RangeValue_Type(); 
			Exact_Type exactValue[] = new Exact_Type[] {
					new Exact_Type((double)countValue)}; 
			value.setExact(exactValue); 
			resource.setTotalCPUCount(value); 			
		}
		
		// FIXME: According to various HPC2N admins, 
		// one should only use walltime. If cputime is 
		// specified, the specified value should be multiplied
		// with 1.2, and set as walltime. 
		
		// cputime, what to do about wallTime? 
		// Note, this is the max CPU time, but due to 
		// compatability with other middleware (e.g., ARC)
		// the CPU time is expressed as exact value, 
		// not as RangeValue_Type.lowerbound or similar...
		Long cpuTime = rsl.getMaxCpuTime(); 
		if(cpuTime != null) {
			long time = cpuTime.longValue(); 
			// JSDL expresses time in seconds...
			long timeInSeconds = time * 60; 
			RangeValue_Type value = new RangeValue_Type();
			Exact_Type exact[] = new Exact_Type[] {
					new Exact_Type((double) timeInSeconds)}; 
			value.setExact(exact); 
			resource.setIndividualCPUTime(value); 
		}
		
		Long wallTime = rsl.getMaxWallTime(); 
		if(wallTime != null) {
			// User may have specified both, what now? 
			// -> Add both, let consuming system select which one to use...				
			long time = wallTime.longValue(); 
			long timeInSeconds = time * 60; 
			RangeValue_Type value = new RangeValue_Type();
			Exact_Type exact[] = new Exact_Type[] {
					new Exact_Type((double) timeInSeconds)}; 
			value.setExact(exact); 
			resource.setIndividualCPUTime(value); 				
		}
		
		// maxMemory, same as about apply, 
		// should perhaps express this as a 
		// RangeValue_Type.lowerbound. 
		NonNegativeInteger memory = rsl.getMaxMemory(); 
		if(memory != null) {
			int memoryValue = memory.intValue(); 
			RangeValue_Type value = new RangeValue_Type(); 
			Exact_Type exact[] = new Exact_Type[] {
					new Exact_Type((double) memoryValue)}; 
			value.setExact(exact); 
			resource.setIndividualPhysicalMemory(value); 
		}
		
		// minMemory, the need for bounds is getting obvious. 
		NonNegativeInteger minMemory = rsl.getMinMemory(); 
		if(minMemory != null) {
			int memoryValue = minMemory.intValue(); 
			RangeValue_Type value = new RangeValue_Type(); 
			Exact_Type exact[] = new Exact_Type[] {
					new Exact_Type((double) memoryValue)}; 
			value.setExact(exact); 
			resource.setIndividualPhysicalMemory(value); 
		}		
		
		// Connect jsdl object. 
		MessageElement any[] = AnyHelper.toAnyArray(posixApplication); 
		application.set_any(any); 
		jsdlDesc.setApplication(application); 
		jsdlDesc.setResources(resource); 
		jsdl.setJobDescription(jsdlDesc); 
		
		return jsdl; 
	}
	
}
