/*
 * Created on Apr 21, 2005
 *
 * TODO Implement it, then write some documentation
 *
 */

package se.umu.wsag.client;


import java.io.FileInputStream; 
import java.util.Calendar; 

import org.apache.axis.message.addressing.EndpointReferenceType; 

import org.globus.axis.util.Util; 
import org.globus.wsrf.encoding.ObjectDeserializer;

import org.oasis.wsrf.lifetime.Destroy; 
import org.oasis.wsrf.lifetime.SetTerminationTime; 

import org.xml.sax.InputSource;

//import se.umu.jobsubmission.reserver.Reservation; 
//import se.umu.jobsubmission.reserver.ReservationServiceAddressingLocator;
import org.ggf.ws_agreement.Agreement;
import org.ggf.ws_agreement.AgreementServiceAddressingLocator;


/**
 * @author tordsson
 *
 * Client for committing reservations - test purposes only
 */
public class DestroyClient {

	
    static {
        Util.registerTransport(); 
    }
	
	public static void main(String[] args) {
		

        try {

            if(args.length < 1) {
                System.err.println("Usage: ReservationCancel eprFile");
                System.exit(1); 
            }
 
            String eprFileName = args[0];
            
            AgreementServiceAddressingLocator locator = 
            	new AgreementServiceAddressingLocator();             

            // Get EPR from file
            FileInputStream fileInputStream = new FileInputStream(eprFileName); 
            EndpointReferenceType epr = (EndpointReferenceType)
                ObjectDeserializer.deserialize( 
                        new InputSource(fileInputStream), 
                        EndpointReferenceType.class); 
            fileInputStream.close(); 

            // Get reference to agreement and destroy it.
            Agreement agreement = locator.getAgreementPort(epr); 


            System.out.println("Destroying agreement now..."); 
            agreement.destroy(new Destroy()); 

            // Avoid building new clients...
            // Destroy resource within 30 seconds. 
            if(args.length > 1) {
            	int period = Integer.parseInt(args[1]);
            	System.out.println("Destroying agreement in " + period 
            			+ "seconds"); 
                Calendar now = Calendar.getInstance(); 
                now.add(Calendar.SECOND, period); 
                SetTerminationTime termTime = new SetTerminationTime(now);
                agreement.setTerminationTime(termTime);          
            }

        } catch (Exception e) {
            System.err.println("Error:");
            e.printStackTrace(); 
        }
    }	
}
